Index: trunk/source/processes/hadronic/cross_sections/src/G4ProtonInelasticCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4ProtonInelasticCrossSection.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4ProtonInelasticCrossSection.cc	(revision 1228)
@@ -27,4 +27,5 @@
 // G.Folger, 29-sept-2006: extend to 1TeV, using a constant above 20GeV
 // 22 Dec 2006 - DHW added isotope dependence
+// G.Folger, 25-Nov-2009: extend to 100TeV, using a constant above 20GeV
 //
 
Index: trunk/source/processes/hadronic/cross_sections/src/G4TripathiLightCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4TripathiLightCrossSection.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4TripathiLightCrossSection.cc	(revision 1228)
@@ -153,7 +153,4 @@
   pT = pT + pP;
   G4double E_cm = (pT.mag()-mT-pP.m())/MeV;
-  if(E_cm <= DBL_MIN) return result;  
-
-
 //
 //
@@ -172,6 +169,5 @@
 
   G4double B = 1.44 * ZP * ZT / Radius;
-  if(E_cm <= B) return result; 
-
+//
 //
 // Now determine other parameters associated with the parametric
@@ -291,9 +287,8 @@
            std::pow((std::pow(AT,third) + std::pow(AP,third) + deltaE),2.0) *
            (1.0 - R_c*B/E_cm) * X_m;
-  if(result < 0.0) result = 0.0;
-  /*
   if (!lowEnergyCheck)
   {
-    if (result < 0.0)  result = 0.0;
+    if (result < 0.0)
+      result = 0.0;
     else if (E < 6.0*MeV)
     {
@@ -301,13 +296,15 @@
       G4DynamicParticle slowerProjectile = *theProjectile;
       slowerProjectile.SetKineticEnergy(f * EA * MeV);
-      G4TripathiLightCrossSection theTripathiLightCrossSection;
-      theTripathiLightCrossSection.SetLowEnergyCheck(true);
+      // G4TripathiLightCrossSection theTripathiLightCrossSection; // MHM 20090824 Not needed
+	  // theTripathiLightCrossSection.SetLowEnergyCheck(true);
+	  G4bool savelowenergy=lowEnergyCheck;
+	  SetLowEnergyCheck(true);
       G4double resultp =
-        theTripathiLightCrossSection.GetIsoZACrossSection
-        (&slowerProjectile, ZZ, AA, 0.0);
+        GetIsoZACrossSection(&slowerProjectile, ZZ, AA, 0.0);
+	  SetLowEnergyCheck(savelowenergy);
       if (resultp >result) result = 0.0;
     }
   }
-  */
+
   return result;
 }
Index: trunk/source/processes/hadronic/cross_sections/src/G4VCrossSectionDataSet.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4VCrossSectionDataSet.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4VCrossSectionDataSet.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4VCrossSectionDataSet.cc,v 1.8 2009/01/24 11:54:47 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/management/History
===================================================================
--- trunk/source/processes/hadronic/management/History	(revision 1227)
+++ trunk/source/processes/hadronic/management/History	(revision 1228)
@@ -14,4 +14,8 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+2 December 2009 Vladimir Ivanchenko (hadr-man-V09-02-05)
+---------------------------------------------------------
+- G4HadronicProcessStore - added protection to the Clean method 
 
 25 February 2009 Vladimir Ivanchenko (hadr-man-V09-02-04)
Index: trunk/source/processes/hadronic/management/include/G4EnergyRangeManager.hh
===================================================================
--- trunk/source/processes/hadronic/management/include/G4EnergyRangeManager.hh	(revision 1227)
+++ trunk/source/processes/hadronic/management/include/G4EnergyRangeManager.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EnergyRangeManager.hh,v 1.9 2006/06/29 19:58:05 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
  // Hadronic Process: Energy Range Manager
Index: trunk/source/processes/hadronic/management/include/G4HadLeadBias.hh
===================================================================
--- trunk/source/processes/hadronic/management/include/G4HadLeadBias.hh	(revision 1227)
+++ trunk/source/processes/hadronic/management/include/G4HadLeadBias.hh	(revision 1228)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/processes/hadronic/management/include/G4HadronicProcessStore.hh
===================================================================
--- trunk/source/processes/hadronic/management/include/G4HadronicProcessStore.hh	(revision 1227)
+++ trunk/source/processes/hadronic/management/include/G4HadronicProcessStore.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4HadronicProcessStore.hh,v 1.5 2009/02/15 16:50:15 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/management/include/G4HadronicProcessType.hh
===================================================================
--- trunk/source/processes/hadronic/management/include/G4HadronicProcessType.hh	(revision 1227)
+++ trunk/source/processes/hadronic/management/include/G4HadronicProcessType.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HadronicProcessType.hh,v 1.1 2008/10/02 19:02:03 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/management/include/G4VLeadingParticleBiasing.hh
===================================================================
--- trunk/source/processes/hadronic/management/include/G4VLeadingParticleBiasing.hh	(revision 1227)
+++ trunk/source/processes/hadronic/management/include/G4VLeadingParticleBiasing.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4VLeadingParticleBiasing.hh,v 1.6 2006/06/29 19:58:19 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/processes/hadronic/management/src/G4EnergyRangeManager.cc
===================================================================
--- trunk/source/processes/hadronic/management/src/G4EnergyRangeManager.cc	(revision 1227)
+++ trunk/source/processes/hadronic/management/src/G4EnergyRangeManager.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EnergyRangeManager.cc,v 1.15 2006/06/29 19:58:21 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
  // Hadronic Process: Energy Range Manager
Index: trunk/source/processes/hadronic/management/src/G4HadronicProcessStore.cc
===================================================================
--- trunk/source/processes/hadronic/management/src/G4HadronicProcessStore.cc	(revision 1227)
+++ trunk/source/processes/hadronic/management/src/G4HadronicProcessStore.cc	(revision 1228)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4HadronicProcessStore.cc,v 1.12 2009/02/25 16:29:03 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// $Id: G4HadronicProcessStore.cc,v 1.13 2009/12/02 15:56:02 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -------------------------------------------------------------------
@@ -92,6 +92,7 @@
         //G4cout << "G4HadronicProcessStore::Clean() delete hadronic " << i << G4endl;
 	//G4cout <<  process[i]->GetProcessName() << G4endl;
-	delete process[i];
+	G4HadronicProcess* p = process[i]; 
 	process[i] = 0;
+	delete p;
       }
     }
@@ -103,6 +104,7 @@
 	//       << i << G4endl;
 	//G4cout << extraProcess[i]->GetProcessName() << G4endl;
-	delete extraProcess[i];
+	G4VProcess* p = extraProcess[i]; 
         extraProcess[i] = 0;
+	delete p;
       }
     }
@@ -362,5 +364,5 @@
   if(0 < n_proc) {
     for(G4int i=0; i<n_proc; i++) {
-      if(process[i] == proc) return;
+      if(process[i] == proc) { return; }
     }
   }
Index: trunk/source/processes/hadronic/models/abrasion/include/G4WilsonAbrasionModel.hh
===================================================================
--- trunk/source/processes/hadronic/models/abrasion/include/G4WilsonAbrasionModel.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/abrasion/include/G4WilsonAbrasionModel.hh	(revision 1228)
@@ -40,6 +40,6 @@
 // MODULE:              G4WilsonAbrasionModel.hh
 //
-// Version:		B.1
-// Date:		15/04/04
+// Version:		1.0
+// Date:		08/12/2009
 // Author:		P R Truscott
 // Organisation:	QinetiQ Ltd, UK
@@ -57,4 +57,8 @@
 // 15 March 2004, P R Truscott, QinetiQ Ltd, UK
 // Beta release
+//
+// 08 December 2009, P R Truscott, QinetiQ Ltd, Ltd
+// ver 1.0
+// Variable fradius defined. See .cc file for more details.
 //
 // %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@@ -119,4 +123,5 @@
     G4double               B;
     G4double               third;
+    G4double               fradius;
 };
 ////////////////////////////////////////////////////////////////////////////////
Index: trunk/source/processes/hadronic/models/abrasion/src/G4WilsonAbrasionModel.cc
===================================================================
--- trunk/source/processes/hadronic/models/abrasion/src/G4WilsonAbrasionModel.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/abrasion/src/G4WilsonAbrasionModel.cc	(revision 1228)
@@ -38,6 +38,6 @@
 // MODULE:              G4WilsonAbrasionModel.cc
 //
-// Version:		B.2
-// Date:		18/01/05
+// Version:		1.0
+// Date:		08/12/2009
 // Author:		P R Truscott
 // Organisation:	QinetiQ Ltd, UK
@@ -60,4 +60,19 @@
 // handler deleted to prevent memory leaks.  Also particle change of projectile
 // fragment previously not properly defined.
+//
+// 08 December 2009, P R Truscott, QinetiQ Ltd, Ltd
+// ver 1.0
+// There was originally a possibility of the minimum impact parameter AFTER
+// considering Couloumb repulsion, rm, being too large.  Now if:
+//     rm >= fradius * (rP + rT)
+// where fradius is currently 0.99, then it is assumed the primary track is
+// unchanged.  Additional conditions to escape from while-loop over impact
+// parameter: if the loop counter evtcnt reaches 1000, the primary track is
+// continued.
+// Additional clauses have been included in
+//    G4WilsonAbrasionModel::GetNucleonInducedExcitation
+// Previously it was possible to get sqrt of negative number as Wilson algorithm
+// not properly defined if either:
+//    rT > rP && rsq < rTsq - rPsq) or (rP > rT && rsq < rPsq - rTsq)
 //
 // %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@@ -151,4 +166,5 @@
   B                = 10.0 * MeV;
   third            = 1.0 / 3.0;
+  fradius          = 0.99;
   conserveEnergy   = false;
   conserveMomentum = true;
@@ -197,4 +213,5 @@
   B                = 10.0 * MeV;
   third            = 1.0 / 3.0;
+  fradius          = 0.99;
   conserveEnergy   = false;
   conserveMomentum = true;
@@ -208,6 +225,9 @@
 // The destructor doesn't have to do a great deal!
 //
-  delete theExcitationHandler;
-  delete theExcitationHandlerx;
+  if (theExcitationHandler)  delete theExcitationHandler;
+  if (theExcitationHandlerx) delete theExcitationHandlerx;
+  if (useAblation)           delete theAblation;
+//  delete theExcitationHandler;
+//  delete theExcitationHandlerx;
 }
 ////////////////////////////////////////////////////////////////////////////////
@@ -304,10 +324,57 @@
     G4double rPT   = rP + rT;
     G4double rPTsq = rPT * rPT;
+//
+//
+// This is a "catch" to make sure we don't go into an infinite loop because the
+// energy is too low to overcome nuclear repulsion.  PRT 20091023.  If the
+// value of rm < fradius * rPT then we're unlikely to sample a small enough
+// impact parameter (energy of incident particle is too low).  Return primary
+// and don't complete nuclear interaction analysis. 
+//
+    if (rm >= fradius * rPT) {
+      theParticleChange.SetStatusChange(isAlive);
+      theParticleChange.SetEnergyChange(theTrack.GetKineticEnergy());
+      theParticleChange.SetMomentumChange(theTrack.Get4Momentum().vect().unit());
+      if (verboseLevel >= 2) {
+        G4cout <<"Particle energy too low to overcome repulsion." <<G4endl;
+        G4cout <<"Event rejected and original track maintained" <<G4endl;
+        G4cout <<"########################################"
+               <<"########################################"
+               <<G4endl;
+      }
+      return &theParticleChange;
+    }
+//
+//
+// Now sample impact parameter until the criterion is met that projectile
+// and target overlap, but repulsion is taken into consideration.
+//
+    G4int evtcnt   = 0;
     r              = 1.1 * rPT;
-    while (r > rPT)
+    while (r > rPT && ++evtcnt < 1000)
     {
       G4double bsq = rPTsq * G4UniformRand();
       r            = (rm + std::sqrt(rm*rm + 4.0*bsq)) / 2.0;
     }
+//
+//
+// We've tried to sample this 1000 times, but failed.  Assume nuclei do not
+// collide.
+//
+    if (evtcnt >= 1000) {
+      theParticleChange.SetStatusChange(isAlive);
+      theParticleChange.SetEnergyChange(theTrack.GetKineticEnergy());
+      theParticleChange.SetMomentumChange(theTrack.Get4Momentum().vect().unit());
+      if (verboseLevel >= 2) {
+        G4cout <<"Particle energy too low to overcome repulsion." <<G4endl;
+        G4cout <<"Event rejected and original track maintained" <<G4endl;
+        G4cout <<"########################################"
+               <<"########################################"
+               <<G4endl;
+      }
+      return &theParticleChange;
+    }
+
+
     rsq = r * r;
 //
@@ -764,7 +831,31 @@
   if (r > rT) Cl = 2.0*std::sqrt(rPsq + 2.0*r*rT - rsq - rTsq);
   else        Cl = 2.0*rP;
-  
-  G4double bP = (rPsq+rsq-rTsq)/2.0/r;
-  G4double Ct = 2.0*std::sqrt(rPsq - bP*bP);
+//
+//
+// The next lines have been changed to include a "catch" to make sure if the
+// projectile and target are too close, Ct is set to twice rP or twice rT.
+// Otherwise the standard Wilson algorithm should work fine.
+// PRT 20091023.
+//
+  G4double Ct = 0.0;
+  if      (rT > rP && rsq < rTsq - rPsq) Ct = 2.0 * rP;
+  else if (rP > rT && rsq < rPsq - rTsq) Ct = 2.0 * rT;
+  else {
+    G4double bP = (rPsq+rsq-rTsq)/2.0/r;
+    G4double x  = rPsq - bP*bP;
+    if (x < 0.0) {
+      G4cerr <<"########################################"
+             <<"########################################"
+             <<G4endl;
+      G4cerr <<"ERROR IN G4WilsonAbrasionModel::GetNucleonInducedExcitation"
+             <<G4endl;
+      G4cerr <<"rPsq - bP*bP < 0.0 and cannot be square-rooted" <<G4endl;
+      G4cerr <<"Set to zero instead" <<G4endl;
+      G4cerr <<"########################################"
+             <<"########################################"
+             <<G4endl;
+    }
+    Ct = 2.0*std::sqrt(x);
+  }
   
   G4double Ex = 13.0 * Cl / fermi;
Index: trunk/source/processes/hadronic/models/binary_cascade/History
===================================================================
--- trunk/source/processes/hadronic/models/binary_cascade/History	(revision 1227)
+++ trunk/source/processes/hadronic/models/binary_cascade/History	(revision 1228)
@@ -13,4 +13,9 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+4-Dec-2009, Gunter Folger                had-binary-V09-02-06
+- Bug fix in G4BinaryCascade::ApplyCollision; decay products outside
+   nucleus were nevertheless counted in currentZ/A as if these were within
+   nucleus.
 
 13-Nov-2009, Gunter Folger               had-binary-V09-02-05
Index: trunk/source/processes/hadronic/models/binary_cascade/include/G4BinaryCascade.hh
===================================================================
--- trunk/source/processes/hadronic/models/binary_cascade/include/G4BinaryCascade.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/binary_cascade/include/G4BinaryCascade.hh	(revision 1228)
@@ -1,3 +1,3 @@
-
+//
 // ********************************************************************
 // * License and Disclaimer                                           *
Index: trunk/source/processes/hadronic/models/binary_cascade/src/G4BinaryCascade.cc
===================================================================
--- trunk/source/processes/hadronic/models/binary_cascade/src/G4BinaryCascade.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/binary_cascade/src/G4BinaryCascade.cc	(revision 1228)
@@ -787,11 +787,11 @@
 // get A and Z for the residual nucleus
   #if defined(debug_G4BinaryCascade) || defined(debug_BIC_GetExcitationEnergy)
-  G4int finalA = theTargetList.size()+theCapturedList.size();
-  G4int finalZ = GetTotalCharge(theTargetList)+GetTotalCharge(theCapturedList);
-  if ( (currentA - finalA) != 0 || (currentZ - finalZ) != 0 )
-  {
-     G4cerr << "G4BIC:GetExcitationEnergy(): Nucleon counting error current/final{A,Z} " 
-            << currentA << " " << finalA << " "<< currentZ << " " << finalZ << G4endl;
-  }
+     G4int finalA = theTargetList.size()+theCapturedList.size();
+     G4int finalZ = GetTotalCharge(theTargetList)+GetTotalCharge(theCapturedList);
+     if ( (currentA - finalA) != 0 || (currentZ - finalZ) != 0 )
+     {
+	G4cerr << "G4BIC:GetExcitationEnergy(): Nucleon counting error current/final{A,Z} " 
+               << currentA << " " << finalA << " "<< currentZ << " " << finalZ << G4endl;
+     }
   
   #endif
@@ -852,5 +852,5 @@
       initialExc = theInitial4Mom.mag()-
            G4ParticleTable::GetParticleTable()->GetIonTable()->GetIonMass(Z, A);
-	   G4cout << " Initial nucleus A Z" << A << " " << Z << initialExc << G4endl; 
+	   G4cout << "GetExcitationEnergy: Initial nucleus A Z " << A << " " << Z << " " << initialExc << G4endl; 
     }
   }
@@ -1081,5 +1081,4 @@
   G4int initialBaryon(0);
   G4int initialCharge(0);
-  G4double initial_Efermi(0);
   G4LorentzVector mom4Primary(0);
   
@@ -1090,24 +1089,27 @@
   }
 
-// for primary resonances, subtract neutron ( = proton) field ( ie. add std::abs(field))
   G4int PDGcode=std::abs(primary->GetDefinition()->GetPDGEncoding());
   mom4Primary=primary->Get4Momentum();
-  initial_Efermi=RKprop->GetField(primary->GetDefinition()->GetPDGEncoding(),primary->GetPosition());
-
-  if ( PDGcode > 1000 && PDGcode != 2112 && PDGcode != 2212 )
-  {
-     initial_Efermi = RKprop->GetField(G4Neutron::Neutron()->GetPDGEncoding(),
-                                                primary->GetPosition());
-     primary->Update4Momentum(mom4Primary.e() - initial_Efermi);
-  }
-
-  std::vector<G4KineticTrack *>::iterator titer;
-  for ( titer=target_collection.begin() ; titer!=target_collection.end(); ++titer)
-  {
-     G4ParticleDefinition * aDef=(*titer)->GetDefinition();
-     G4int aCode=aDef->GetPDGEncoding();
-     G4ThreeVector aPos=(*titer)->GetPosition();
-     initial_Efermi+= RKprop->GetField(aCode, aPos);
-//     initial_Efermi+= RKprop->GetField((*titer)->GetDefinition()->GetPDGEncoding(),(*titer)->GetPosition());
+
+// for primary resonances, subtract neutron ( = proton) field ( ie. add std::abs(field))
+  G4double initial_Efermi(0);
+  if (primary->GetState() == G4KineticTrack::inside ) {
+     initial_Efermi=RKprop->GetField(primary->GetDefinition()->GetPDGEncoding(),primary->GetPosition());
+
+     if ( PDGcode > 1000 && PDGcode != 2112 && PDGcode != 2212 )
+     {
+	initial_Efermi = RKprop->GetField(G4Neutron::Neutron()->GetPDGEncoding(),
+                                                   primary->GetPosition());
+	primary->Update4Momentum(mom4Primary.e() - initial_Efermi);
+     }
+
+     std::vector<G4KineticTrack *>::iterator titer;
+     for ( titer=target_collection.begin() ; titer!=target_collection.end(); ++titer)
+     {
+	G4ParticleDefinition * aDef=(*titer)->GetDefinition();
+	G4int aCode=aDef->GetPDGEncoding();
+	G4ThreeVector aPos=(*titer)->GetPosition();
+	initial_Efermi+= RKprop->GetField(aCode, aPos);
+     }
   }
 //****************************************
@@ -1140,5 +1142,5 @@
      G4bool lateParticleCollision= (!haveTarget) && products && products->size() == 1;
 	//  if ( lateParticleCollision ) G4cout << " Added late particle--------------------------"<<G4endl;
-	//  if ( products ) PrintKTVector(products, " reaction products");
+	//  if ( lateParticleCollision && products ) PrintKTVector(products, " reaction products");
 //****************************************  
 
@@ -1172,38 +1174,40 @@
   }
 
-   G4double final_Efermi(0);
-   G4KineticTrackVector resonances;
-   for ( std::vector<G4KineticTrack *>::iterator i =products->begin(); i != products->end(); i++)
-   {
-       G4int PDGcode=std::abs((*i)->GetDefinition()->GetPDGEncoding());
-//       G4cout << " PDGcode, state " << PDGcode << " " << (*i)->GetState()<<G4endl;
-       final_Efermi+=RKprop->GetField(PDGcode,(*i)->GetPosition());
-       if ( PDGcode > 1000 && PDGcode != 2112 && PDGcode != 2212 )
-       {  
-	  resonances.push_back(*i);
-       }
-   }	
-   if ( resonances.size() > 0 ) 
-   {  
-      G4double delta_Fermi= (initial_Efermi-final_Efermi)/resonances.size();
-      for (std::vector<G4KineticTrack *>::iterator res=resonances.begin(); res != resonances.end(); res++)
-      {
-	  G4LorentzVector mom=(*res)->Get4Momentum();
-	  G4double mass2=mom.mag2();
-	  G4double newEnergy=mom.e() + delta_Fermi;
-	  G4double newEnergy2= newEnergy*newEnergy;
-	  	//G4cout << "mom = " << mom <<" newE " << newEnergy<< G4endl;
-	  if ( newEnergy2 < mass2 )
-	  {
-             ClearAndDestroy(products);
-             if (target_collection.size() == 0 ) FindDecayCollision(primary);  // for decay, sample new decay
-	     delete products;
-	     return false;
-	  }
-//	  G4cout << " correct resonance from /to " << mom.e() << " / " << newEnergy<< G4endl;
-	  G4ThreeVector mom3=std::sqrt(newEnergy2 - mass2) * mom.vect().unit();
-	  (*res)->Set4Momentum(G4LorentzVector(mom3,newEnergy));
-      }
-   }
+  if (primary->GetState() == G4KineticTrack::inside ) {   // if the primary was outside, nothing to correct
+     G4double final_Efermi(0);
+     G4KineticTrackVector resonances;
+     for ( std::vector<G4KineticTrack *>::iterator i =products->begin(); i != products->end(); i++)
+     {
+	 G4int PDGcode=std::abs((*i)->GetDefinition()->GetPDGEncoding());
+         //       G4cout << " PDGcode, state " << PDGcode << " " << (*i)->GetState()<<G4endl;
+	 final_Efermi+=RKprop->GetField(PDGcode,(*i)->GetPosition());
+	 if ( PDGcode > 1000 && PDGcode != 2112 && PDGcode != 2212 )
+	 {  
+	    resonances.push_back(*i);
+	 }
+     }	
+     if ( resonances.size() > 0 ) 
+     {  
+	G4double delta_Fermi= (initial_Efermi-final_Efermi)/resonances.size();
+	for (std::vector<G4KineticTrack *>::iterator res=resonances.begin(); res != resonances.end(); res++)
+	{
+	    G4LorentzVector mom=(*res)->Get4Momentum();
+	    G4double mass2=mom.mag2();
+	    G4double newEnergy=mom.e() + delta_Fermi;
+	    G4double newEnergy2= newEnergy*newEnergy;
+	  	  //G4cout << "mom = " << mom <<" newE " << newEnergy<< G4endl;
+	    if ( newEnergy2 < mass2 )
+	    {
+               ClearAndDestroy(products);
+               if (target_collection.size() == 0 ) FindDecayCollision(primary);  // for decay, sample new decay
+	       delete products;
+	       return false;
+	    }
+            //	  G4cout << " correct resonance from /to " << mom.e() << " / " << newEnergy<< G4endl;
+	    G4ThreeVector mom3=std::sqrt(newEnergy2 - mass2) * mom.vect().unit();
+	    (*res)->Set4Momentum(G4LorentzVector(mom3,newEnergy));
+	}
+     }
+  }
 
 #ifdef debug_BIC_ApplyCollision
@@ -1218,7 +1222,9 @@
     if ( ! lateParticleCollision ) 
     {
-       (*i)->SetState(primary->GetState());  // secondaries are created inside nucleus, except for decay in propagate
-       finalBaryon+=(*i)->GetDefinition()->GetBaryonNumber();
-       finalCharge+=G4lrint((*i)->GetDefinition()->GetPDGCharge());
+       (*i)->SetState(primary->GetState());  // decay may be anywhere!
+       if ( (*i)->GetState() == G4KineticTrack::inside ){
+          finalBaryon+=(*i)->GetDefinition()->GetBaryonNumber();
+          finalCharge+=G4lrint((*i)->GetDefinition()->GetPDGCharge());
+       }
     } else {
        G4double tin=0., tout=0.; 
@@ -1247,5 +1253,5 @@
        }
        
-//       G4cout << " PDGcode, state " << (*i)->GetDefinition()->GetPDGEncoding() << " " << (*i)->GetState()<<G4endl;
+       //G4cout << " PDGcode, state " << (*i)->GetDefinition()->GetPDGEncoding() << " " << (*i)->GetState()<<G4endl;
 
     }   
@@ -1269,5 +1275,5 @@
   currentA += finalBaryon-initialBaryon;
   currentZ += finalCharge-initialCharge;
-	//G4cout << " currentA, Z aft: " << currentA << " " << currentZ << G4endl;
+	//G4cout << " ApplyCollision currentA, Z aft: " << currentA << " " << currentZ << G4endl;
   
   G4KineticTrackVector oldSecondaries;
@@ -2351,5 +2357,5 @@
      G4cerr << "G4BinaryCascade::GetFinal4Momentum - Fatal"<<G4endl;
      G4KineticTrackVector::iterator i;
-     G4cerr <<" Initial nucleus "<<theInitial4Mom<<G4endl;
+     G4cerr <<" GetFinal4Momentum: Initial nucleus "<<theInitial4Mom<<G4endl;
      for(i = theProjectileList.begin() ; i != theProjectileList.end(); ++i)
      {
Index: trunk/source/processes/hadronic/models/cascade/History
===================================================================
--- trunk/source/processes/hadronic/models/cascade/History	(revision 1227)
+++ trunk/source/processes/hadronic/models/cascade/History	(revision 1228)
@@ -15,4 +15,9 @@
      ---------------------------------------------------------------
 
+1 Dec 2009 Dennis Wright (hadr-casc-V09-02-11)
+----------------------------------------------
+- G4PionSampler, G4NucleonSampler: change loop variable in ctor from i to j
+  in order to satisfy Windows compiler
+ 
 11 Nov 2009 Dennis Wright (hadr-casc-V09-02-10)
 -----------------------------------------------
Index: trunk/source/processes/hadronic/models/cascade/cascade/include/G4CascadeMomentum.hh
===================================================================
--- trunk/source/processes/hadronic/models/cascade/cascade/include/G4CascadeMomentum.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/cascade/cascade/include/G4CascadeMomentum.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4CascadeMomentum.hh,v 1.1 2008/09/22 10:06:32 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/cascade/cascade/include/G4FinalStateSampler.hh
===================================================================
--- trunk/source/processes/hadronic/models/cascade/cascade/include/G4FinalStateSampler.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/cascade/cascade/include/G4FinalStateSampler.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateSampler.hh,v 1.2 2009/09/17 18:11:57 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: D. H. Wright
Index: trunk/source/processes/hadronic/models/cascade/cascade/include/G4NucleonSampler.hh
===================================================================
--- trunk/source/processes/hadronic/models/cascade/cascade/include/G4NucleonSampler.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/cascade/cascade/include/G4NucleonSampler.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4NucleonSampler.hh,v 1.1 2009/09/24 18:50:27 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: D. H. Wright
Index: trunk/source/processes/hadronic/models/cascade/cascade/include/G4PionSampler.hh
===================================================================
--- trunk/source/processes/hadronic/models/cascade/cascade/include/G4PionSampler.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/cascade/cascade/include/G4PionSampler.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PionSampler.hh,v 1.2 2009/09/17 18:10:44 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: D. H. Wright
Index: trunk/source/processes/hadronic/models/cascade/cascade/src/G4FinalStateSampler.cc
===================================================================
--- trunk/source/processes/hadronic/models/cascade/cascade/src/G4FinalStateSampler.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/cascade/cascade/src/G4FinalStateSampler.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateSampler.cc,v 1.2 2009/09/17 18:15:38 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/hadronic/models/cascade/cascade/src/G4NucleiModel.cc
===================================================================
--- trunk/source/processes/hadronic/models/cascade/cascade/src/G4NucleiModel.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/cascade/cascade/src/G4NucleiModel.cc	(revision 1228)
@@ -969,10 +969,10 @@
 
   G4double rat;
-  G4double ratm;
+  //  G4double ratm;
 
   // Calculate number of protons and neutrons in local region
-  G4double Athird = std::pow(A, 0.3333);
-  G4double Nneut = Athird*(A-Z)/A;
-  G4double Nprot = Athird*Z/A;
+  //  G4double Athird = std::pow(A, 0.3333);
+  //  G4double Nneut = Athird*(A-Z)/A;
+  //  G4double Nprot = Athird*Z/A;
 
   // Reduce number of 
@@ -985,7 +985,7 @@
 
     // Calculate ratio modified for local region
-    G4double deltaP = protonNumber - protonNumberCurrent;
+    //    G4double deltaP = protonNumber - protonNumberCurrent;
     //    G4cout << " deltaP = " << deltaP << G4endl;
-    ratm = std::max(0.0, (Nprot - deltaP)/Nprot);
+    //    ratm = std::max(0.0, (Nprot - deltaP)/Nprot);
 
   } else {
@@ -997,7 +997,7 @@
 
     // Calculate ratio modified for local region
-    G4double deltaN = neutronNumber - neutronNumberCurrent;
+    //    G4double deltaN = neutronNumber - neutronNumberCurrent;
     //   G4cout << " deltaN = " << deltaN << G4endl;
-    ratm = std::max(0.0, (Nneut - deltaN)/Nneut);
+    //    ratm = std::max(0.0, (Nneut - deltaN)/Nneut);
   }
 
Index: trunk/source/processes/hadronic/models/cascade/cascade/src/G4NucleonSampler.cc
===================================================================
--- trunk/source/processes/hadronic/models/cascade/cascade/src/G4NucleonSampler.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/cascade/cascade/src/G4NucleonSampler.cc	(revision 1228)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4NucleonSampler.cc,v 1.1 2009/09/24 18:51:14 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// $Id: G4NucleonSampler.cc,v 1.2 2009/12/02 17:34:57 dennis Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
  
@@ -62,5 +62,5 @@
   }
 
-  G4int i, k, m;
+  G4int j, k, m;
   G4int start, stop;
 
@@ -70,5 +70,5 @@
     for (k = 0; k < 30; k++) {
       t1_dSigma_dMult[m][k] = 0.0;
-      for (i = start; i < stop; i++) t1_dSigma_dMult[m][k] += PPCrossSections[i][k];
+      for (j = start; j < stop; j++) t1_dSigma_dMult[m][k] += PPCrossSections[j][k];
     }
 
@@ -77,5 +77,5 @@
     for (k = 0; k < 30; k++) {
       t0_dSigma_dMult[m][k] = 0.0;
-      for (i = start; i < stop; i++) t0_dSigma_dMult[m][k] += NPCrossSections[i][k];
+      for (j = start; j < stop; j++) t0_dSigma_dMult[m][k] += NPCrossSections[j][k];
     }
   }
